#include"main.h"	
/***************************************************************************
    "SVT" Phillip Blair's Spanish Vocabulary Tutor 
    Copyright (C) 1997  Phillip Vaughn Blair
    phillip_blair@writeme.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

**************************************************************************/
void build_database(void)
{
   int leaveorstayor;
   char cool_to_leave = 0;

   open_database_formods();
   do
     {
	erase();/*clear screen*/
	refresh();
	switch(get_words_from_user())
	  {
	     case 0:
	     refresh();
	     erase();
	     refresh();
	     break;
	     case 1:
	     leaveorstayor=stick_it_on();
	     erase();
	     refresh();
	     break;
	     case -1:
	     cool_to_leave = 1;
	     break;
	  }
	refresh();
	}
   while(!cool_to_leave);
   
   close_database_frommods();
}

unsigned long int stick_it_on(void)
{
   frame insertion;
   datum key,nextkey,content;
   int i;
   char cool;
   cool = 1;
   if(!no_of_records)
     {
	key = gdbm_firstkey(dbfvar);
	if(key.dptr!=NULL)/* if there is a first  key, there's  probably a  next, */
	  {
	     for(i=0;i<100&&cool;i++)
	       {
		  no_of_records = no_of_records+1;
		  nextkey = gdbm_nextkey(dbfvar,key);
		  if(nextkey.dptr==NULL)
		    cool=0;
		  key = nextkey;
	       }
	  }
	else
	  no_of_records = 0;
     }/*okay,we now know how many existing entries (keys)...plus one...there are in the database,we can NOW add stuff after the end  of the database because we now have a numerical handle on that*/
   /*compose the frame(record)*/
   strcpy(insertion.spanish,spanish);
   strcpy(insertion.english,english);
   insertion.right = 0;
   insertion.wrong = 0;
   insertion.ltiwa = 0;
   content.dptr=(char*)&insertion;
   content.dsize=sizeof(insertion);
   /*frame composed*/
   /*now  stick it on*/
   key.dptr=(char*)&no_of_records;
   key.dsize=sizeof(no_of_records);
   if((gdbm_store(dbfvar,key,content,GDBM_INSERT)))
     {
	move(17,10);
	addstr("could not insert data in database ");
	move(18,10);
	addstr("something's gone terribly wrong recently...");
	refresh();
	sleep(2);
	exit(EXIT_FAILURE);
     }
   else
     {
	no_of_records++; 
	mvprintw(17,10,"next record: %lu",no_of_records);
	refresh();
	sleep(1);
     }
   return no_of_records;
}

void open_database_formods(void)
{
   char nouns_file_path[450];
   strcpy(nouns_file_path,data_dir_name);
   strcat(nouns_file_path,"/nouns.spdbf");
   if((dbfvar = gdbm_open(nouns_file_path,510,
		      GDBM_WRCREAT,0644,0))==NULL)
     {
	move(17,10);
	addstr("could not open database for modification");
	refresh();
	sleep(2);
	exit(EXIT_FAILURE);
     }

}
void close_database_frommods(void)
{
   gdbm_close(dbfvar);
}

char get_words_from_user(void)
{
   char cool = 0;
   int character;
   erase();
   refresh();
   move(9,10);
   addstr("please enter the english word of the pair:");
   refresh();
   get_lne(10,10,english,20);
   move(11,10);
   addstr("please enter the spanish word of the pair:");
   get_lne(12,10,spanish,20);
   
   move(14,10);
   addstr("the spanish is:");
   move(15,10);
   addstr(spanish);
   move(16,10);
   addstr("the english is:");
   move(17,10);
   addstr(english);
   move(18,10);
   addstr("is this correct? (y,N,q)");
   refresh();
   do
     {
	character = getch();
	switch(character)
	  {
	     case KEY_RETURN:
	     case'n':
	     ret_var = 0;
	     cool=1;
	     break;
	     
	     case'y':
	     ret_var = 1;
	     cool=1;
	     break;	       
	     
	     
	     case'q':
	     ret_var = -1;
	     cool=1;
	     break;
	  }
     }while(!cool);
   return ret_var;
}

void get_lne(char y_in,char x_in,char *english_ptr,char in_length)
{
   /* fr. the line_out constructor */
   string = malloc(201); /* wider than the widest screen! */
   x = 10;
   y = 10;
   pos = 0;   

   /* fr the line_in constructor */
   length = 20;
   position = 0;
   memset(final_string,0,200);
   memset(blanks,32,200);
   /* fr setpos */
   x = x_in;
   y = y_in;
   /* fr setlen */
   length = in_length;   



   move(y,x+pos);
   refresh();
   do
     {
	character = getch();
	switch(character)
	  {
	     case KEY_LEFT :
	     left_key_handler();
	     break;
	     
	     case KEY_RIGHT :
	     right_key_handler();
	     break;
	     
	     case KEY_BACKSPACE :
	     backspace_key_handler();
	     break;
	     
	     
	     case KEY_RETURN :
	     /* do nothing in this case! */
	     break;
	     
	     
	     default :
	     my_default_handler(&character);
	     break;
	  }
	putupblanks();
	line_out_setline(final_string);
	line_out_setcursorpos(position);
	line_out_activate();
     }
   while(character!=KEY_RETURN);
   strcpy(english_ptr,final_string); /* copy the gotten string to the output variable */
   
   /* fr.the line_out destructor */
   free(string);
   
   return;
}

   
   
   

   
   
void left_key_handler(void)
{
   if(position > 0)
	 position--;
}

void right_key_handler(void)
{
   if(position < length)
	 position = position + 1;
}

void my_default_handler(int *character)
{
   if(position < length)
	 {
		if(position < strlen(final_string))
		  {
			 strcpy(temp_final,final_string + position);
			 final_string[position] = *character;
			 strcpy(final_string + position + 1,temp_final);
			 position++;
			 final_string[length] = 0;/* fix for small bug */
		  }
		else
		  {
			 final_string[position] = *character;
			 position++;
			 final_string[position] = 0;
		  }
	 }
}

void backspace_key_handler(void)
{
   if(position > 0)
     {
	position--;
	memmove(final_string + position,final_string + position  + 1,30);
     }
}

void putupblanks(void)
{
   memcpy(temp_blanks,blanks,200); /* create our temporary row of blanks */
   temp_blanks[length + 1] = 0;
   move(y,x);
   addstr(temp_blanks);
}



void line_out_setline(char *input_string)
{
   strcpy(string,input_string);
}

void line_out_setpos(char x_in,char y_in)
{
   x = x_in;
   y = y_in;
}

void line_out_setcursorpos(char pos_in)
{
   pos = pos_in;   
}

void line_out_activate(void)
{
   move(y,x);
   addstr(string);
   move(y,x + pos);
   refresh();
}
